chiark / gitweb /
keyfunc.sh: Protect arguments to expr(1).
[distorted-keys] / keyfunc.sh.in
1 ### -*-sh-*-
2 ###
3 ### Common key management functions.
4 ###
5 ### (c) 2011 Mark Wooding
6 ###
7
8 ###----- Licensing notice ---------------------------------------------------
9 ###
10 ### This file is part of the distorted.org.uk key management suite.
11 ###
12 ### distorted-keys is free software; you can redistribute it and/or modify
13 ### it under the terms of the GNU General Public License as published by
14 ### the Free Software Foundation; either version 2 of the License, or
15 ### (at your option) any later version.
16 ###
17 ### distorted-keys is distributed in the hope that it will be useful,
18 ### but WITHOUT ANY WARRANTY; without even the implied warranty of
19 ### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
20 ### GNU General Public License for more details.
21 ###
22 ### You should have received a copy of the GNU General Public License
23 ### along with distorted-keys; if not, write to the Free Software Foundation,
24 ### Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
25
26 quis=${0##*/}
27
28 ###--------------------------------------------------------------------------
29 ### Configuration variables.
30
31 ## Automatically configured pathnames.
32 PACKAGE="@PACKAGE@" VERSION="@VERSION@"
33 bindir="@bindir@"
34
35 ## Read user configuration.
36 if [ -f $ETC/keys.conf ]; then . $ETC/keys.conf; fi
37
38 ## Maybe turn on debugging.
39 case "${KEYS_DEBUG+t}" in t) set -x ;; esac
40
41 ## Fake up caller credentials if not called via userv.
42 case "${USERV_USER+t}" in
43   t) ;;
44   *) USERV_USER=${LOGNAME-${USER-$(id -un)}} USERV_UID=$(id -u) ;;
45 esac
46 case "${USERV_GROUP+t}" in
47   t) ;;
48   *) USERV_GROUP=$(id -Gn) USERV_GID=$(id -gn) ;;
49 esac
50
51 ###--------------------------------------------------------------------------
52 ### Cleanup handling.
53
54 cleanups=""
55 cleanup () { cleanups=${cleanups+$cleanups }$1; }
56 runcleanups () { for i in $cleanups; do $i; done; }
57 trap 'rc=$?; runcleanups; exit $rc' EXIT
58 trap 'trap "" EXIT; runcleanups; exit 127' INT TERM
59
60 ###--------------------------------------------------------------------------
61 ### Utility functions.
62
63 reqsafe () {
64   ## Fail unless a safe directory is set.
65
66   err="$quis: (CONFIGURATION ERROR)"
67   case ${SAFE+t} in
68     t) ;;
69     *) echo >&2 "$err: no SAFE directory"; exit 1 ;;
70   esac
71   if [ ! -d "$SAFE" ]; then
72     echo >&2 "$err: SAFE path \`$SAFE' isn't a directory"
73     exit 1
74   fi
75   case "$SAFE" in
76     [!/]* | *[][[:space:]*?]*)
77       echo >&2 "$err: SAFE path \`$SAFE' contains bad characters"
78       exit 1
79       ;;
80   esac
81   ls -ld "$SAFE" | {
82     me=$(id -un)
83     read perm _ user stuff
84     case "$perm:$user" in
85       d???------:"$me") ;;
86       *)
87         echo >&2 "$err: SAFE path \`$SAFE' has bad owner or permissions"
88         exit 1
89         ;;
90     esac
91   }
92 }
93
94 ## Temporary directory.
95 unset tmp
96 rmtmp () { case ${tmp+t} in t) cd /; rm -rf $tmp ;; esac; }
97 cleanup rmtmp
98 mktmp () {
99   ## Make a temporary directory and store its name in `tmp'.
100
101   case "${tmp+t}" in t) return ;; esac
102   reqsafe
103   tmp="$SAFE/keys.tmp.$$"
104   rm -rf "$tmp"
105   mkdir -m700 "$tmp"
106 }
107
108 reqtmp () {
109   ## Fail unless a temporary directory is set.
110
111   case ${tmp+t} in
112     t) ;;
113     *) echo >&2 "$quis (INTERNAL): no tmp directory set"; exit 127 ;;
114   esac
115 }
116
117 parse_keylabel () {
118   key=$1
119   ## Parse the key label string KEY.  Set `kdir' to the base path to use for
120   ## the key's storage, and `kowner' to the key owner's name.
121
122   case "$key" in
123     *:*) kowner=${key%%:*} klabel=${key#*:} ;;
124     *) kowner=$USERV_USER klabel=$key ;;
125   esac
126   checkword "key owner name" "$kowner"
127   checklabel "key" "$klabel"
128   kdir=$KEYS/store/$kowner/$klabel
129   knub=$KEYS/nub/$kowner/$klabel
130 }
131
132 ###--------------------------------------------------------------------------
133 ### Input validation functions.
134
135 nl="
136 "
137 check () {
138   ckwhat=$1 ckpat=$2 thing=$3
139   ## Verify that THING matches the (anchored, basic) regular expression
140   ## CKPAT.  Since matching newlines is hard to do portably, also check that
141   ## THING doesn't contain any.  If the checks fail, report an error and
142   ## exit.
143
144   validp=t
145   case "$thing" in
146     *"$nl"*) validp=nil ;;
147     *) if ! expr >/dev/null "Q$thing" : "Q$ckpat\$"; then validp=nil; fi ;;
148   esac
149   case $validp in
150     nil) echo >&2 "$quis: bad $ckwhat \`$thing'"; exit 1 ;;
151   esac
152 }
153
154 ## Regular expressions for validating input.
155 R_IDENTCHARS="A-Za-z0-9_"
156 R_WORDCHARS="-$R_IDENTCHARS!%@+="
157 R_IDENT="[$R_IDENTCHARS][$R_IDENTCHARS]*"
158 R_WORD="[$R_WORDCHARS][$R_WORDCHARS]*"
159 R_WORDSEQ="[$R_WORDCHARS[:space:]][$R_WORDCHARS[:space:]]*"
160 R_NUMERIC='\(\([1-9][0-9]*\)\{0,1\}0\{0,1\}\)'
161 R_LABEL="\($R_WORD\(/$R_WORD\)*\)"
162 R_LINE=".*"
163
164 ## Various validation functions.
165 checknumber () { check "$1" "$R_NUMERIC" "$2"; }
166 checkident () { check "$1" "$R_IDENT" "$2"; }
167 checkword () { check "$1" "$R_WORD" "$2"; }
168 checklabel () { check "$1 label" "$R_LABEL" "$2"; }
169
170 ###--------------------------------------------------------------------------
171 ### Key storage and properties.
172
173 getsysprofile () {
174   profile=$1
175   ## Write the named system PROFILE to standard output.
176
177   $bindir/extract-profile "$profile" $ETC/profile.d/
178 }
179
180 setprops () {
181   what=$1 prefix=$2; shift 2
182   ## Set variables based on the NAME=VALUE assignments in the arguments.  The
183   ## value for property NAME is stored in the shell variable PREFIX_NAME.
184
185   for assg in "$@"; do
186     goodp=t
187     case "$assg" in
188       *\=*) name=${assg%%=*} value=${assg#*=} ;;
189       *) goodp=nil ;;
190     esac
191     case "$goodp,$name" in t,*[!0-9A-Za-z_]*=*) goodp=nil ;; esac
192     case "$goodp" in
193       nil) echo >&2 "$quis: bad $what assignment \`$assg'"; exit 1 ;;
194     esac
195     eval "$prefix$name=\$value"
196   done
197 }
198
199 checkprops () {
200   whatprop=$1 prefix=$2; shift 2
201   ## Check that property variables are set in accordance with the remaining
202   ## TABLE arguments.  Each row of TABLE has the form
203   ##
204   ##    NAME OMIT PAT
205   ##
206   ## A table row is satisfied if there is a variable PREFIXNAME whose value
207   ## matces the (basic) regular expression PAT, or if the variable is unset
208   ## and OMIT is `t'.
209
210   for table in "$@"; do
211     case "$table" in ?*) ;; *) continue ;; esac
212     while read -r name omit pat; do
213       eval foundp=\${$prefix$name+t}
214       case "$foundp,$omit" in
215         ,t) continue ;;
216         ,nil)
217           echo >&2 "$quis: missing $whatprop \`$name' required"
218           exit 1
219           ;;
220       esac
221       eval value=\$$prefix$name
222       check "value for $whatprop \`$name'" "$pat" "$value"
223     done <<EOF
224 $table
225 EOF
226   done
227 }
228
229 defprops () {
230   name=$1
231   ## Define a properties table NAME.
232
233   table=$(cat)
234   eval $name=\$table
235 }
236
237 defprops g_props <<EOF
238 type                    nil     $R_IDENT
239 recovery                t       $R_WORDSEQ
240 random                  t       $R_WORD
241 nub_hash                t       $R_WORD
242 nubid_hash              t       $R_WORD
243 nub_random_bytes        t       $R_NUMERIC
244 EOF
245
246 readprops () {
247   file=$1
248   ## Read a profile from a file.  This doesn't check the form of the
249   ## filename, so it's not suitable for unchecked input.  Properties are set
250   ## using `setprops' with prefix `kprop_'.
251
252   ## Parse the settings from the file.
253   exec 3<"$file"
254   while read line; do
255     case "$line" in "" | \#*) continue ;; esac
256     setprops "property" kprop_ "$line"
257   done <&3
258   exec 3>&-
259   checkprops "property" kprop_ "$g_props"
260
261   ## Fetch the key-type handling library.
262   if [ ! -f $KEYSLIB/ktype.$kprop_type ]; then
263     echo >&2 "$quis: unknown key type \`$kprop_type'"
264     exit 1
265   fi
266   . $KEYSLIB/ktype.$kprop_type
267   checkprops "property" kprop_ "$k_props"
268 }
269
270 readmeta () {
271   kdir=$1
272   ## Read key metadata from KDIR.
273
274   { read profile; } <"$kdir"/meta
275 }
276
277 makenub () {
278   ## Generate a key nub in the default way, and write it to standard output.
279   ## The properties `random', `nub_random_bytes' and `nub_hash' are referred
280   ## to.
281
282   dd 2>/dev/null \
283     if=/dev/${kprop_random-random} bs=1 count=${kprop_nub_random_bytes-64} |
284   openssl dgst -${kprop_nub_hash-sha256} -binary |
285   openssl base64
286 }
287
288 nubid () {
289   ## Compute a hash of the key nub in stdin, and write it to stdout in hex.
290   ## The property `nubid_hash' is used.
291
292   { echo "distorted-keys nubid"; cat -; } |
293   openssl dgst -${kprop_nubid_hash-sha256}
294 }
295
296 subst () {
297   what=$1 templ=$2 prefix=$3 pat=$4
298   ## Substitute option values into the template TEMPL.  Each occurrence of
299   ## %{VAR} is replaced by the value of the variable PREFIXVAR.  Finally, an
300   ## error is reported unless the final value matches the regular expression
301   ## PAT.
302
303   out=""
304   rest=$templ
305   while :; do
306
307     ## If there are no more markers to substitute, then finish.
308     case "$rest" in *"%{"*"}"*) ;; *) out=$out$rest; break ;; esac
309
310     ## Split the template into three parts.
311     left=${rest%%\%\{*} right=${rest#*\%\{}
312     var=${right%%\}*} rest=${right#*\}}
313     case "$var" in
314       *-*) default=${var#*-} var=${var%%-*} defaultp=t ;;
315       *) defaultp=nil ;;
316     esac
317
318     ## Find the variable value.
319     checkident "template variable name" "$var"
320     eval foundp=\${$prefix$var+t}
321     case $foundp,$defaultp in
322       t,*) eval value=\$$prefix$var ;;
323       ,t) value=$default ;;
324       *)
325         echo >&2 "$quis: option \`$var' unset, used in template \`$templ'"
326         exit 1
327         ;;
328     esac
329
330     ## Do the substitution.
331     out=$out$left$value
332   done
333
334   ## Check the final result.
335   check "$what" "$pat" "$out"
336
337   ## Done.
338   echo "$out"
339 }
340
341 read_profile () {
342   owner=$1 profile=$2
343   ## Read property settings from a profile.  The PROFILE name has the form
344   ## [USER:]LABEL; USER defaults to OWNER.  Properties are set using
345   ## `setprops' with prefix `kprop_'.
346
347   reqtmp
348   case "$profile" in
349     :*)
350       label=${profile#:} uservp=nil
351       ;;
352     *)
353       user=$kowner label=$profile uservp=t
354       ;;
355     *:*)
356       user=${profile%%:*} label=${profile#*:} uservp=t
357       ;;
358   esac
359   checkword "profile label" "$label"
360
361   ## Fetch the profile settings from the user.
362   reqtmp
363   case $uservp in
364     t)
365       checkword "profile user" "$user"
366       userv "$user" cryptop-profile "$label" >$tmp/profile
367       ;;
368     nil)
369       $bindir/extract-profile "$label" $ETC/profile.d/ >$tmp/profile
370       ;;
371   esac
372
373   ## Read the file.
374   readprops $tmp/profile
375 }
376
377 ###--------------------------------------------------------------------------
378 ### General crypto operations.
379
380 c_genkey () {
381   profile=$1 kdir=$2 knub=$3 hook=$4; shift 4
382   ## Generate a key, and associate it with the named PROFILE (which is
383   ## assumed already to have been read!); store the main data in KDIR, and
384   ## the nub separately in the file KNUB; run HOOK after generation, passing
385   ## it the working key directory and nub file.  Remaining arguments are
386   ## options to the key type.
387
388   ## Set options and check them.
389   setprops "option" kopt_ "$@"
390   checkprops "option" kopt_ "$k_genopts"
391
392   ## Create directory structure and start writing metadata.
393   rm -rf "$kdir.new"
394   mkdir -m755 -p "$kdir.new"
395   case "$knub" in */*) mkdir -m700 -p "${knub%/*}" ;; esac
396   cat >"$kdir.new/meta" <<EOF
397 $profile
398 EOF
399
400   ## Generate the key.
401   umask=$(umask); umask 077; >"$knub.new"; umask $umask
402   k_generate "$kdir.new" "$knub.new"
403   $hook "$kdir.new" "$knub.new"
404
405   ## Hash the nub.
406   nubid <"$knub.new" >"$kdir.new/nubid"
407
408   ## Juggle everything into place.  Doing this atomically is very difficult,
409   ## and requires more machinery than I can really justify here.  If
410   ## something goes wrong halfway, it should always be possible to fix it,
411   ## either by backing out (if $kdir.new still exists) or pressing on
412   ## forwards (if not).
413   rm -rf "$kdir.old"
414   if [ -e "$kdir" ]; then mv "$kdir" "$kdir.old"; fi
415   mv "$kdir.new" "$kdir"
416   mv "$knub.new" "$knub"
417   rm -rf "$kdir.old"
418 }
419
420 c_encrypt () { k_encrypt "$@"; }
421 c_decrypt () {
422   if k_decrypt "$@" >$tmp/plain; then cat $tmp/plain
423   else return $?
424   fi
425 }
426 c_sign () { k_sign "$@"; }
427 c_verify () { k_verify "$@"; }
428
429 ## Stub implementations.
430 notsupp () { op=$1; echo >&2 "$quis: operation \`$op' not supported"; }
431 k_info () { :; }
432 k_encrypt () { notsupp encrypt; }
433 k_decrypt () { notsupp decrypt; }
434 k_sign () { notsupp sign; }
435 k_verify () { notsupp verify; }
436
437 prepare () {
438   key=$1 op=$2
439   ## Prepare for a crypto operation OP, using the KEY.  This validates the
440   ## key label, reads the profile, and checks the access-control list.  If OP
441   ## is `-' then allow the operation unconditionally.
442
443   ## Find the key properties.
444   parse_keylabel "$key"
445   if [ ! -d $kdir ]; then echo >&2 "$quis: unknown key \`$key'"; exit 1; fi
446   readmeta $kdir
447   read_profile $kowner "$profile"
448
449   ## Check whether we're allowed to do this thing.  This is annoyingly
450   ## fiddly.
451   case $op in -) return ;; esac
452   eval acl=\${kprop_acl_$op-!owner}
453   verdict=forbid
454   while :; do
455
456     ## Remove leading whitespace.
457     while :; do
458       case "$acl" in
459         [[:space:]]*) acl=${acl#?} ;;
460         *) break ;;
461       esac
462     done
463
464     ## If there's nothing left, leave.
465     case "$acl" in ?*) ;; *) break ;; esac
466
467     ## Split off the leading word.
468     case "$acl" in
469       *[[:space:]]*) word=${acl%%[[:space:]]*} acl=${acl#*[[:space:]]} ;;
470       *) word=$acl acl="" ;;
471     esac
472
473     ## See what sense it has if it matches.
474     case "$word" in
475       -*) sense=forbid rest=${word#-} ;;
476       *) sense=allow rest=$word ;;
477     esac
478
479     ## See whether the calling user matches.
480     case "$rest" in
481       !owner) pat=$kowner list=$USERV_USER ;;
482       !*) echo >&2 "$quis: unknown ACL token \`$word'" ;;
483       %*) pat=${rest#%} list="$USERV_GROUP $USERV_GID" ;;
484       *) pat=$rest list="$USERV_USER $USERV_UID" ;;
485     esac
486     matchp=nil
487     for i in $list; do case "$i" in $pat) matchp=t; break ;; esac; done
488     case $matchp in t) verdict=$sense; break ;; esac
489   done
490
491   case $verdict in
492     forbid) echo >&2 "$quis: $op access to key \`$key' forbidden"; exit 1 ;;
493   esac
494 }
495
496 ###--------------------------------------------------------------------------
497 ### Crypto operations for infrastructure purposes.
498
499 c_sysprofile () {
500   profile=$1
501   ## Select the profile in FILE for future crypto operations.
502
503   unset $(set | sed -n '/^kprop_/s/=.*$//p')
504   reqtmp
505   getsysprofile "$profile" >$tmp/profile
506   readprops $tmp/profile
507 }
508
509 c_gensyskey () {
510   profile=$1 kdir=$2 knub=$3; shift 3
511   ## Generate a system key using PROFILE; store the data in KDIR and the nub
512   ## in KNUB.  Remaining arguments are options.
513
514   c_sysprofile "$profile"
515   c_genkey "$profile" "$kdir" "$knub" : "$@"
516 }
517
518 c_sysprepare () {
519   kdir=$1
520   readmeta "$kdir"
521   c_sysprofile "$profile"
522 }
523
524 c_sysop () {
525   op=$1 kdir=$2; shift 1
526   c_sysprepare "$kdir"
527   c_$op "$@"
528 }
529
530 c_sysencrypt () { c_sysop encrypt "$1" /dev/null; }
531 c_sysdecrypt () { c_sysop decrypt "$1" "$2"; }
532 c_syssign () { c_sysop sign "$1" "$2"; }
533 c_sysverify () { c_sysop verify "$1" /dev/null; }
534
535 ###--------------------------------------------------------------------------
536 ### Recovery operations.
537
538 stash () {
539   recov=$1 label=$2
540   ## Stash a copy of stdin encrypted under the recovery key RECOV, with a
541   ## given LABEL.
542   checkword "recovery key label" "$recov"
543   checklabel "secret" "$label"
544
545   rdir=$KEYS/recov/$recov/current
546   if [ ! -d $rdir/store ]; then
547     echo >&2 "$quis: unknown recovery key \`$recov'"
548     exit 1
549   fi
550   case $label in */*) mkdir -m755 -p $rdir/${label%/*} ;; esac
551   (c_sysencrypt $rdir/store >$rdir/$label.new)
552   mv $rdir/$label.new $rdir/$label.recov
553 }
554
555 recover () {
556   recov=$1 label=$2
557   ## Recover a stashed secret, protected by RECOV and stored as LABEL, and
558   ## write it to stdout.
559   checkword "recovery key label" "$recov"
560   checklabel "secret" "$label"
561
562   rdir=$KEYS/recov/$recov/current
563   if [ ! -f $rdir/$label.recov ]; then
564     echo >&2 "$quis: no blob for \`$label' under recovery key \`$recov'"
565     exit 1
566   fi
567   reqsafe
568   nub=$SAFE/keys.reveal/$recov.current/nub
569   if [ ! -f $nub ]; then
570     echo >&2 "$quis: current recovery key \`$recov' not revealed"
571     exit 1;
572   fi
573   mktmp
574   c_sysdecrypt $rdir/store $nub <$rdir/$label.recov
575 }
576
577 ###--------------------------------------------------------------------------
578 ### Help text.
579
580 defhelp () {
581   read umsg
582   usage="usage: $quis${umsg+ }$umsg"
583   help=$(cat)
584   case "$KEYS_HELP" in t) help; exit ;; esac
585 }
586
587 help () { showhelp; }
588 showhelp () {
589   cat <<EOF
590 $usage
591
592 $help
593 EOF
594 }
595
596 usage_err () { echo >&2 "$usage"; exit 1; }
597
598 ###--------------------------------------------------------------------------
599 ### Subcommand handling.
600
601 version () {
602   echo "$PACKAGE version $VERSION"
603 }
604
605 cmd_help () {
606   rc=0
607   version
608   case $# in
609     0)
610       cat <<EOF
611
612 $usage
613
614 Options:
615   -h            Show this help text.
616   -v            Show the program version number.
617
618 Commands installed:
619 EOF
620       cd "$KEYSLIB"
621       for i in $prefix.*; do
622         if [ ! -x "$i" ]; then continue; fi
623         sed -n "/<<HELP/{n;s/^/ ${i#$prefix.} /;p;q;}" "$i"
624       done
625       ;;
626     *)
627       for i in "$@"; do
628         echo
629         if [ ! -x "$KEYSLIB/$prefix.$i" ]; then
630           echo >&2 "$quis: unrecognized command \`$i'"
631           rc=1
632           continue
633         elif ! KEYS_HELP=t "$KEYSLIB/$prefix.$i"; then
634           rc=1
635         fi
636       done
637       ;;
638   esac
639   return $rc
640 }
641
642 dispatch () {
643   case $# in 0) echo >&2 "$usage"; exit 1 ;; esac
644   cmd=$1; shift
645   case "$cmd" in help) cmd_help "$@"; exit ;; esac
646   if [ ! -x "$KEYSLIB/$prefix.$cmd" ]; then
647     echo >&2 "$quis: unrecognized command \`$cmd'"
648     exit 1
649   fi
650
651   unset KEYS_HELP
652   exec "$KEYSLIB/$prefix.$cmd" "$@"
653 }
654
655 ###----- That's all, folks --------------------------------------------------